#include <dlfcn.h>
#include <stdio.h>

int
main (void)
{
  void *handle;
  void (*init_func) ();

  handle = (void *)dlopen ("./test.so", RTLD_LAZY|RTLD_GLOBAL);
  if (handle == NULL)
    {
      fprintf (stderr, "dlopen failed\n");
      exit (1);
    }
  init_func = (void (*) ()) dlsym (handle, "init_test");
  if (init_func == NULL)
    {
      fprintf (stderr, "dlsym failed\n");
      exit (1);
    }
  (*init_func) ();

  return 0;
}
